typedef struct Cart Cart;
typedef struct Realm Realm;
typedef struct UserInfo {
  char name[32];
  uvlong password;
  Cart* cart;
  Realm* realm;
  char* scope;
  int random;
  int ctl_code;
} UserInfo;

UserInfo* find_user(UserInfo* table, char* uname);
int* ctl_code_handle(UserInfo* table, char* uname);
int login(UserInfo* table, char* uname, char* password);
int logout(UserInfo* table, char* uname);
int protect_realm(UserInfo* table, char* uname, char* password);
int transfer_realm(UserInfo* table, char* from, char* to);
int load_cart(UserInfo* table, char* uname, char* cart_name);
int enter_realm(UserInfo* table, char* uname, char* realm_name);
int leave_realm(UserInfo* table, char* uname);
int unload_cart(UserInfo* table, char* uname);
int delete_realm(UserInfo* table, char* uname, char* realm);